<?php
/*
Plugin Name: cw_authors_info
Plugin URI: http://www.conociendowordpress.com/blog/2012/04/02/cw-author-info-nuevo-plugin-para-mostrar-informacion-de-los-redactores-de-un-blog/
Description: Adds an author box after your post contents and widget y sidebar.The box contains author's avatar,name,site link,personal description, link to Twitter, Facebook, Google+ and Email.
Author: antocara
Version: 1.0
Author URI: http://www.conociendowordpress.com
*/
/*
Copyright 2012  Antonio Carabantes(Email : antocara@gmail.com)

This program is free software: you can redistribute it and/or modify

it under the terms of the GNU General Public License as published by

the Free Software Foundation, either version 3 of the License, or

(at your option) any later version.

This program is distributed in the hope that it will be useful,

but WITHOUT ANY WARRANTY; without even the implied warranty of

MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the

GNU General Public License for more details.

You should have received a copy of the GNU General Public License

along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/
?>
<?php
/***************
* Primero aadimos los campos de las redes sociales en la pgina de adminsitracin de usuarios de Wordpress
******************/
add_action('show_user_profile', 'cw_info_authors');
add_action('edit_user_profile', 'cw_info_authors');
	
	function cw_info_authors($user){ ?>
		<?php global $current_user;
		 		get_currentuserinfo(); ?>
		<h3><?php _e('Rellena estos campos para tu perfil personal','cw_tex_author');?></h3>
		<table class="form-table">
		<th><?php _e('Facebook:','cw_tex_author');?> </th><td><input type="text" name="cw_facebook" size="30" value="<?php echo esc_url($current_user->cw_facebook); ?>"/><span class="description"><?php _e('Ejem: http://www.facebook.com/user','cw_tex_author');?></span></td></tr>
		<th><?php _e('Twitter:', 'cw_tex_author');?> </th><td><input type="text" name="cw_twitter" size="30" value="<?php echo esc_url($current_user->cw_twitter); ?>"/><span class="description"><?php _e('Ejem: http://www.twitter.com/user', 'cw_tex_author');?></span></td></tr>
		<th><?php _e('Google+:','cw_tex_author');?> </th><td><input type="text" name="cw_google_plus" size="40" value="<?php echo esc_url($current_user->cw_google_plus); ?>"/><span class="description"><?php _e('Ejem: https://plus.google.com/user','cw_tex_author');?></span></td></tr>
		</table>
			
	<?php } 

/**************
 * actualizamos los metadatas del usuario en la base de datos 
 *****************/	
add_action( 'personal_options_update', 'cw_info_authors_save' );
add_action( 'edit_user_profile_update', 'cw_info_authors_save' );

	function cw_info_authors_save(){ 
		global $current_user;
		 		get_currentuserinfo();   
		update_user_meta($current_user->ID, 'cw_facebook', $_POST['cw_facebook']);
		update_user_meta($current_user->ID, 'cw_twitter', $_POST['cw_twitter']);
		update_user_meta($current_user->ID, 'cw_google_plus', $_POST['cw_google_plus']);
	}
/**************
 * insertamos los datos despus del post 
 *****************/		
	add_filter('the_content', 'cw_author_post');
	add_action('wp_enqueue_scripts', 'add_my_css'); /* cargo hoja de estilso del plugin*/
		function add_my_css() {
        $myStyleUrl = plugins_url('css/author_box.css', __FILE__); 
        $myStyleFile = WP_PLUGIN_DIR . '/cw_authors_info/css/author_box.css';
	        if ( file_exists($myStyleFile) ) {
	            wp_register_style('author_box', $myStyleUrl);
	            wp_enqueue_style( 'author_box');
	        }
   		 }
		
			
		function cw_author_post($content){
			$cw_url = plugins_url('images/', __FILE__); //ruta de imagenes dentro del plugin
			$caja=' <div class="author_post_bio">
					
					<div class="cw_author_name"><p>'. __('Conoce algo m&aacutes al autor de este post:','cw_tex_author').'</p>' .'<a href="'.get_author_posts_url( get_the_author_meta('ID') ).'">'.get_the_author_meta('display_name').'</a></div>
					<div class="avatar">'. get_avatar( get_the_author_meta( 'user_email' ), '96' ).'
						<div class="social_author">
						
							<a href="'.get_the_author_meta('cw_facebook').'"><img alt="icon_facebook" src="'. $cw_url.'facebook.png" width="20" height="20" /> </a>
							<a href="'.get_the_author_meta('cw_twitter').'"><img alt="icon_twitter" src="'.$cw_url.'twitter.png" width="20" height="20" /></a>
							<a href="'.get_the_author_meta( 'cw_google_plus' ).'"><img alt="icon_google+" src="'.$cw_url.'gplus.png" width="20" height="20" /></a>
							<a href="mailto:'.get_the_author_meta( 'user_email' ).'"><img alt="icon_email" src="'. $cw_url.'email.png" width="20" height="20" /></a>
						</div>
					
					</div>
					<div class="author-description">
						'.get_the_author_meta( 'description' ).'
					</div>
			
				</div>';
				if (is_single()){
					
					$content.=$caja;
				}
				
			
			return $content;
			
			
		}	
/**************
 * Creacion panel de opciones del plugin 
 *****************/
	
//cargamos el script javascript		
		function my_admin_head() {
			$url = plugins_url('css/author_box.css', __FILE__);
        	echo '<script type="text/javascript" src="http://meta100.github.com/mColorPicker/javascripts/mColorPicker_min.js" charset="UTF-8"></script>';
			echo '<link rel="stylesheet" type="txt/css" href="'.$url.' " />';
		}

	add_action('admin_head', 'my_admin_head'); 
	
//	Creamos el panel de opciones		
		
	add_action('admin_menu', 'cw_theme_options_admi'); 
		function cw_theme_options_admi(){
			add_submenu_page('users.php', 'Author Info', 'CW Author Info', 'read', 'color_picker_option', 'cw_author_option_page');
		}
		function cw_author_option_page(){
			if ( isset($_POST['update_options'])) { cw_author_option_page_update(); }
			?>
				<div class="cw_wrap">
					<div id="icon-themes" class="icon32" ><br></div>
					<h2><?php _e('Opciones Author Info','cw_tex_author');?> </h2>
					 <form id="cw_form" class="form-table" method="POST" action="">
					 	<table class="form-table">
				    	 <tr class="form-field"><th scope="row"><?php _e('Elige color de fondo del cuadro de autor: ','cw_tex_author');?></th><td><input type="color" id="color1" value="<?php echo get_option( 'color1' );?>" name="color_picker_color1" data-text="hidden" style="height:20px;width:20px;"/></td></tr>
				     	 <tr class="form-field"><th scope="row"><?php _e('Elige color para las letras del cuadro de autor: ','cw_tex_author');?></th><td><input type="color" id="color2" value="<?php echo get_option( 'color2' );?>" name="color_picker_color2" data-text="hidden" style="height:20px;width:20px;" /></td></tr>
				    	 <tr class="form-field"><th scope="row"><label><?php _e('Elige color del borde inferior del cuadro de autor: ','cw_tex_author');?></label></th><td><input type="color" id="color3" value="<?php echo get_option( 'color3' );?>" name="color_picker_color3" data-text="hidden" style="height:20px;width:20px;" /></td></tr>
				     	</table>
				     	
				     	<p><input type="submit" name="update_options" value="<?php _e('Guardar opciones', 'cw_text_author');?>" /></p>
					</form>
					<div id="pay">
			
						<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
							<input type="hidden" name="cmd" value="_s-xclick">
							<input type="hidden" name="hosted_button_id" value="Y5TG8EW2DJRF6">
							<p>If you like the plugin, please consider donating a buck or two by clicking the button below, thanks</p>
							<input type="image" src="https://www.paypalobjects.com/en_US/GB/i/btn/btn_donateCC_LG.gif" border="0" name="submit" alt="PayPal  The safer, easier way to pay online.">
							<img alt="" border="0" src="https://www.paypalobjects.com/es_ES/i/scr/pixel.gif" width="1" height="1">
						</form>

					</div>
				</div>
				
			<?php }
// Guardamos los datos elegidos
		function cw_author_option_page_update(){
			update_option('color1', esc_html($_POST['color_picker_color1']));
			update_option('color2', esc_html($_POST['color_picker_color2']));
			update_option('color3', esc_html($_POST['color_picker_color3']));
			
		}
// Funcin que carga en el head el estilo a modificar segn colores elegidos
		
		function my_wp_head() {
		    $options = get_option( 'color1' );
		    $options2 = get_option( 'color2' );
		    $options3 = get_option( 'color3' );
		
		        
		    echo "<style> .author_post_bio { background: $options !important; 
		    								 color: $options2 !important;
		    								 border-bottom: 3px solid $options3 !important;	
											} 
									
				</style>";
		   
		}
	add_action( 'wp_head', 'my_wp_head' );	
/**************
 * Creacin widget 
 *****************/		
		class wc_list_author_widget extends WP_Widget {

	function __construct(){
		$opciones = array(
			'classname'     => 'cw_lista_autores',
			'description'   => __('Listado de todos los autores del blog','cw_tex_author')
		);
		parent::__construct('lista_autores', __('Listado de autores','cw_tex_author') , $opciones);
	}

	function widget($args, $instance){
	 extract($args);
     extract($instance);	
     $cw_url = plugins_url('images/', __FILE__); //ruta de imagenes dentro del plugin
     
	 $blogusers = get_users('blog_id=1&orderby=post_count&order=desc'); 
	 		 echo $before_widget;
		if( !empty($titulo))  {
	        echo $before_title.$titulo.$after_title;
	   		 }
	   		  
	   		  
	 	foreach ($blogusers as $user) {
	 			if (user_can($user->ID, 'edit_posts')){
	 				if (count_user_posts( $user->ID )>0){
	 			 
			 
			 echo  '<li><div id="cw_ava">';
			 echo get_avatar( get_the_author_meta( 'user_email',$user->ID ), '35' );
			 echo '</div>';
			 echo '<div id="cw_nom_usu">';
			 echo "<p><a href=\"".get_bloginfo('url')."/?author=";
			 echo $user->ID;
			 echo "\">";
			 the_author_meta('display_name', $user->ID);
			 echo "</a></p></div>"; 
			 ?><div id="cw_cont_post"><?php echo count_user_posts( $user->ID );?></div>  
			 <div id="cw_social_wid">
			 <?php 
			 $cw_author_f=get_the_author_meta('cw_facebook', $user->ID);
			 $cw_author_t=get_the_author_meta('cw_twitter', $user->ID);
			 $cw_author_g=get_the_author_meta('cw_google_plus', $user->ID);
			 $cw_author_m=get_the_author_meta('user_email', $user->ID);
			 if ($cw_author_f){?>
			 <a href="<?php the_author_meta('cw_facebook', $user->ID);?>"><img alt="icon_facebook" src="<?php echo $cw_url;?>facebook.png" width="15" height="15" /></a><?php }
			 if ($cw_author_t){?>
			 <a href="<?php the_author_meta('cw_twitter',$user->ID);?>"><img alt="icon_twitter" src="<?php echo $cw_url;?>twitter.png" width="15" height="15" /></a><?php }
			 if ($cw_author_g){?> 
			 <a href="<?php the_author_meta('cw_google_plus',$user->ID);?>"><img alt="icon_google+" src="<?php echo $cw_url;?>gplus.png" width="15" height="15" /></a><?php } 
			 if ($cw_author_m){?>
			 <a href="mailto:<?php the_author_meta('user_email',$user->ID);?>"><img alt="icon_email" src="<?php echo $cw_url;?>email.png" width="15" height="15" /></a><?php }?></div><?php 
			 echo '</li>';
	 			}
	 			}		
 		}
		echo $after_widget;
	}

	function update($new_instance, $old_instance){
		return array(
        'titulo' => strip_tags($new_instance['titulo']),
		);
		
	}

	function form($instance){
		$instance['titulo'] = esc_attr($instance['titulo']);
		?>
    
    <p>
        <label for="<?php echo $this->get_field_id('titulo'); ?>"><?php _e('T&iacutetulo: ','cw_tex_author');?></label>
        <input value="<?php echo $instance['titulo']; ?>" class="widefat" type="text" id="<?php echo $this->get_field_id('titulo'); ?>" name="<?php echo $this->get_field_name('titulo'); ?>">
    </p>
    	<?php 
		
	}

}


function widget_register_cw_list_author()
{
	register_widget('wc_list_author_widget');
}
add_action('widgets_init', 'widget_register_cw_list_author');
/**************
* Habilitamos las traducciones
*****************/

function cw_traducc_authors_info()
{
	load_plugin_textdomain('cw_tex_author', false, basename( dirname( __FILE__ ) ) . '/languages' );
}
add_action('init', 'cw_traducc_authors_info');
?>